const endpointContainer = document.getElementById('endpoint-container');
const getEndpointsBtn = document.getElementById('get-endpoints-btn');
const resultContainer = document.getElementById('result-container');
const detailContainer = document.getElementById('detail-container');

function getEndpoints() {
    
    fetch('https://swapi.co/api/')
    .then(function(response){
        if(response.ok){
            return response.json();
        }

        return Promise.reject('promise not ok');
    }).then(function(jsonResponse){
        addBtns(jsonResponse);
    })
    .catch(function(error){
        console.error(error);
    });
}

function addBtns(response) {
    const btnHtml = Object.keys(response).reduce(function(html, responseKey) {
        return (
            html +
            '<button data-url="' +
            response[responseKey] +
            '">' +
            responseKey +
            '</button>'
        );
    }, '');

    endpointContainer.innerHTML = btnHtml;
}

function makeRequest(event) {
    if (event.target.matches('button')) {
        let btn = event.target;
        let btnText = btn.innerHTML;
        btn.innerHTML = 'loading...';

       /* let request = new XMLHttpRequest();           zelfde als fetch!!!!

        request.addEventListener('load', function(event) {
            if (event.target.status === 200) {
                let response = JSON.parse(event.target.responseText);
                console.log(response);
                btn.innerHTML = btnText;
            } else {
                console.log(event.target);
                btn.innerHTML = 'Dikke fail...';
            }
        });

        request.open('GET', event.target.dataset.url);
        request.send(); */

        fetch(event.target.dataset.url)
        .then(function(response){
            if(response.ok){
                return response.json();
            }
            return Promise.reject(new Error('request failed'));
        })
        .then(function(jsonResponse){
            btn.innerHTML = btnText;
            console.log(jsonResponse);
            resultContainer.innerHTML = printList(jsonResponse.results); //toevoegen van results
            
        })
        .catch(function(error){
            console.error(error);
            btn.innerHTML = 'dikke fail...';
        });
    }
}

function printList(list){
    
  return  list.reduce(function(html,listItem){
        return `
        ${html}
        <article class= "list-item">
            <p> ${listItem.name? listItem.name:listItem.title}</p>
            <button data-url= "${listItem.url}">Show Detail</button>
        </article>
        `;
            

    }, '');
}
function listDetails(details){
    return Object.keys(details).reduce(function(html, detailKey){
        return `
        ${html}
        <p>
        <strong>${detailKey}:</strong>${details[detailKey]}
        </p>
        `;
    }, '');
}

function requestDetails(event){
    
    if (event.target.matches('button')) {
        let btn = event.target;
        let btnText = btn.innerHTML;
        btn.innerHTML = 'loading...';

        fetch(event.target.dataset.url)
        .then(function(response){
            if(response.ok){
                return response.json();
            }
            return Promise.reject(new Error('request failed'));
        })
        .then(function(jsonResponse){
            btn.innerHTML = btnText;
            console.log(jsonResponse);
            detailContainer.innerHTML = listDetails(jsonResponse);
        })
        .catch(function(error){
            console.error(error);
            btn.innerHTML = 'dikke fail...';
        });
    }
    
}

getEndpointsBtn.addEventListener('click', getEndpoints);
endpointContainer.addEventListener('click', makeRequest);
resultContainer.addEventListener('click',requestDetails);
