const randomWords = [
    'condition',
    'bottom',
    'lineage',
    'trip',
    'reporter',
    'paper',
    'colorful',
    'agent',
    'justify',
    'torture',
    'cap',
    'earthflax',
    'payment',
    'research',
    'picture',
    'garage',
    'honor',
    'memorial',
    'planet',
    'biography',
    'profound',
    'rumor',
    'gear',
    'bedroom',
    'orthodox',
    'penalty',
    'grief',
    'promote',
    'roof',
    'suite',
    'moving',
    'killer',
    'museum',
    'essay',
    'fever',
    'dignity',
    'shadow',
    'enjoy',
    'kill',
    'shy',
    'counter',
    'pawn',
    'button',
    'bullet',
    'skin',
    'rate',
    'shop',
    'consider',
    'other',
    'prospect',
];
const hangManImage = document.querySelector('#image');
const solutionContainer = document.querySelector('#solution-container');
const winOrLoseContainer = document.querySelector('#win-lose-container');
const letterContainer = document.querySelector('#letter-container');
const gameState = {
    word: [],
    hangman: 1,
    turn: 1,
    lettersFound: 0,
    won: false,
    lost: false,
    usedLetters: [],
};
addEventListener('load', init);
winOrLoseContainer.addEventListener('click', init);

function init() {
    reset();
    gameState.word = getWord();
    console.log(gameState.word);
    multiplyPlaceholders();
    letterContainer.addEventListener('click', letterMatching);
}

function getWord() {
    let random = Math.floor(Math.random() * randomWords.length);
    let randomWord = randomWords[random];

    return randomWord.split('');
}

function multiplyPlaceholders() {
    solutionContainer.innerHTML = '';
    gameState.word.forEach(function() {
        let d = document.createElement('div');
        d.classList.add('solution-letter');
        solutionContainer.appendChild(d);
    });
}

function letterMatching(event) {
    if (event.target.matches('.letter')) {
        if (
            !gameState.usedLetters.includes(event.target.innerHTML) &&
            !gameState.won &&
            !gameState.lost
        ) {
            gameState.usedLetters.push(event.target.innerHTML);
            console.log(gameState.usedLetters);
            if (gameState.word.includes(event.target.innerHTML.toLowerCase())) {
                let divs = solutionContainer.children;
                for (let i = 0; i < gameState.word.length; i++) {
                    if (
                        gameState.word[i] ===
                        event.target.innerHTML.toLowerCase()
                    ) {
                        divs[
                            i
                        ].innerHTML = event.target.innerHTML.toLowerCase();
                        gameState.lettersFound++;
                        if (gameState.lettersFound === gameState.word.length) {
                            gameState.won = true;
                            winOrLoseContainer.innerHTML = 'you win!';
                        }
                    }
                }
                event.target.classList.add('success');
            } else {
                event.target.classList.add('failed');
                gameState.hangman++;
                hangManImage.setAttribute(
                    'src',
                    'images/hangman0' + gameState.hangman + '.png'
                );
                if (gameState.hangman == 9) {
                    gameState.lost = true;
                    winOrLoseContainer.innerHTML =
                        'you lose! the word was: ' + gameState.word.join('');
                }
            }
        }
    }
}
function reset() {
    winOrLoseContainer.innerHTML = '';
    gameState.word = [];
    gameState.hangman = 1;
    gameState.turn = 1;
    gameState.lettersFound = 0;
    gameState.won = false;
    gameState.lost = false;
    gameState.usedLetters = [];
    hangManImage.setAttribute('src', 'images/hangman01.png');

    for (let i = 0; i < letterContainer.children.length; i++) {
        letterContainer.children[i].classList.remove('success');
        letterContainer.children[i].classList.remove('failed');
    }
}
